ViewVC Help
View File | Revision Log | Show Annotations | Download File
/cvs/AnyEvent/lib/AnyEvent.pm
(Generate patch)

Comparing AnyEvent/lib/AnyEvent.pm (file contents):
Revision 1.253 by root, Tue Jul 21 06:00:47 2009 UTC vs.
Revision 1.265 by root, Wed Jul 29 13:10:58 2009 UTC

1=head1 NAME 1=head1 NAME
2 2
3AnyEvent - events independent of event loop implementation 3AnyEvent - the DBI of event loop programming
4 4
5EV, Event, Glib, Tk, Perl, Event::Lib, Qt and POE are various supported 5EV, Event, Glib, Tk, Perl, Event::Lib, Irssi, rxvt-unicode, IO::Async, Qt
6event loops. 6and POE are various supported event loops/environments.
7 7
8=head1 SYNOPSIS 8=head1 SYNOPSIS
9 9
10 use AnyEvent; 10 use AnyEvent;
11 11
47 47
48There is a mailinglist for discussing all things AnyEvent, and an IRC 48There is a mailinglist for discussing all things AnyEvent, and an IRC
49channel, too. 49channel, too.
50 50
51See the AnyEvent project page at the B<Schmorpforge Ta-Sa Software 51See the AnyEvent project page at the B<Schmorpforge Ta-Sa Software
52Respository>, at L<http://anyevent.schmorp.de>, for more info. 52Repository>, at L<http://anyevent.schmorp.de>, for more info.
53 53
54=head1 WHY YOU SHOULD USE THIS MODULE (OR NOT) 54=head1 WHY YOU SHOULD USE THIS MODULE (OR NOT)
55 55
56Glib, POE, IO::Async, Event... CPAN offers event models by the dozen 56Glib, POE, IO::Async, Event... CPAN offers event models by the dozen
57nowadays. So what is different about AnyEvent? 57nowadays. So what is different about AnyEvent?
400 400
401=head2 CHILD PROCESS WATCHERS 401=head2 CHILD PROCESS WATCHERS
402 402
403You can also watch on a child process exit and catch its exit status. 403You can also watch on a child process exit and catch its exit status.
404 404
405The child process is specified by the C<pid> argument (if set to C<0>, it 405The child process is specified by the C<pid> argument (one some backends,
406watches for any child process exit). The watcher will triggered only when 406using C<0> watches for any child process exit, on others this will
407the child process has finished and an exit status is available, not on 407croak). The watcher will be triggered only when the child process has
408any trace events (stopped/continued). 408finished and an exit status is available, not on any trace events
409(stopped/continued).
409 410
410The callback will be called with the pid and exit status (as returned by 411The callback will be called with the pid and exit status (as returned by
411waitpid), so unlike other watcher types, you I<can> rely on child watcher 412waitpid), so unlike other watcher types, you I<can> rely on child watcher
412callback arguments. 413callback arguments.
413 414
796 797
797 AnyEvent::Impl::Glib based on Glib, slow but very stable. 798 AnyEvent::Impl::Glib based on Glib, slow but very stable.
798 AnyEvent::Impl::Tk based on Tk, very broken. 799 AnyEvent::Impl::Tk based on Tk, very broken.
799 AnyEvent::Impl::EventLib based on Event::Lib, leaks memory and worse. 800 AnyEvent::Impl::EventLib based on Event::Lib, leaks memory and worse.
800 AnyEvent::Impl::POE based on POE, very slow, some limitations. 801 AnyEvent::Impl::POE based on POE, very slow, some limitations.
802 AnyEvent::Impl::Irssi used when running within irssi.
801 803
802=item Backends with special needs. 804=item Backends with special needs.
803 805
804Qt requires the Qt::Application to be instantiated first, but will 806Qt requires the Qt::Application to be instantiated first, but will
805otherwise be picked up automatically. As long as the main program 807otherwise be picked up automatically. As long as the main program
1084 1086
1085BEGIN { AnyEvent::common_sense } 1087BEGIN { AnyEvent::common_sense }
1086 1088
1087use Carp (); 1089use Carp ();
1088 1090
1089our $VERSION = 4.86; 1091our $VERSION = 4.881;
1090our $MODEL; 1092our $MODEL;
1091 1093
1092our $AUTOLOAD; 1094our $AUTOLOAD;
1093our @ISA; 1095our @ISA;
1094 1096
1119 for reverse split /\s*,\s*/, 1121 for reverse split /\s*,\s*/,
1120 $ENV{PERL_ANYEVENT_PROTOCOLS} || "ipv4,ipv6"; 1122 $ENV{PERL_ANYEVENT_PROTOCOLS} || "ipv4,ipv6";
1121} 1123}
1122 1124
1123my @models = ( 1125my @models = (
1124 [EV:: => AnyEvent::Impl::EV::], 1126 [EV:: => AnyEvent::Impl::EV:: , 1],
1125 [Event:: => AnyEvent::Impl::Event::], 1127 [Event:: => AnyEvent::Impl::Event::, 1],
1126 [AnyEvent::Impl::Perl:: => AnyEvent::Impl::Perl::], 1128 [AnyEvent::Impl::Perl:: => AnyEvent::Impl::Perl:: , 1],
1127 # everything below here will not be autoprobed 1129 # everything below here will not (normally) be autoprobed
1128 # as the pureperl backend should work everywhere 1130 # as the pureperl backend should work everywhere
1129 # and is usually faster 1131 # and is usually faster
1130 [Glib:: => AnyEvent::Impl::Glib::], # becomes extremely slow with many watchers 1132 [Glib:: => AnyEvent::Impl::Glib:: , 1], # becomes extremely slow with many watchers
1131 [Event::Lib:: => AnyEvent::Impl::EventLib::], # too buggy 1133 [Event::Lib:: => AnyEvent::Impl::EventLib::], # too buggy
1134 [Irssi:: => AnyEvent::Impl::Irssi::], # Irssi has a bogus "Event" package
1132 [Tk:: => AnyEvent::Impl::Tk::], # crashes with many handles 1135 [Tk:: => AnyEvent::Impl::Tk::], # crashes with many handles
1133 [Qt:: => AnyEvent::Impl::Qt::], # requires special main program 1136 [Qt:: => AnyEvent::Impl::Qt::], # requires special main program
1134 [POE::Kernel:: => AnyEvent::Impl::POE::], # lasciate ogni speranza 1137 [POE::Kernel:: => AnyEvent::Impl::POE::], # lasciate ogni speranza
1135 [Wx:: => AnyEvent::Impl::POE::], 1138 [Wx:: => AnyEvent::Impl::POE::],
1136 [Prima:: => AnyEvent::Impl::POE::], 1139 [Prima:: => AnyEvent::Impl::POE::],
1137 # IO::Async is just too broken - we would need workarounds for its 1140 # IO::Async is just too broken - we would need workarounds for its
1138 # byzantine signal and broken child handling, among others. 1141 # byzantine signal and broken child handling, among others.
1139 # IO::Async is rather hard to detect, as it doesn't have any 1142 # IO::Async is rather hard to detect, as it doesn't have any
1140 # obvious default class. 1143 # obvious default class.
1141# [IO::Async:: => AnyEvent::Impl::IOAsync::], # requires special main program 1144# [0, IO::Async:: => AnyEvent::Impl::IOAsync::], # requires special main program
1142# [IO::Async::Loop:: => AnyEvent::Impl::IOAsync::], # requires special main program 1145# [0, IO::Async::Loop:: => AnyEvent::Impl::IOAsync::], # requires special main program
1143# [IO::Async::Notifier:: => AnyEvent::Impl::IOAsync::], # requires special main program 1146# [0, IO::Async::Notifier:: => AnyEvent::Impl::IOAsync::], # requires special main program
1144); 1147);
1145 1148
1146our %method = map +($_ => 1), 1149our %method = map +($_ => 1),
1147 qw(io timer time now now_update signal child idle condvar one_event DESTROY); 1150 qw(io timer time now now_update signal child idle condvar one_event DESTROY);
1148 1151
1194 } 1197 }
1195 } 1198 }
1196 } 1199 }
1197 1200
1198 unless ($MODEL) { 1201 unless ($MODEL) {
1199 # try to load a model 1202 # try to autoload a model
1200
1201 for (@REGISTRY, @models) { 1203 for (@REGISTRY, @models) {
1202 my ($package, $model) = @$_; 1204 my ($package, $model, $autoload) = @$_;
1205 if (
1206 $autoload
1203 if (eval "require $package" 1207 and eval "require $package"
1204 and ${"$package\::VERSION"} > 0 1208 and ${"$package\::VERSION"} > 0
1205 and eval "require $model") { 1209 and eval "require $model"
1210 ) {
1206 $MODEL = $model; 1211 $MODEL = $model;
1207 warn "AnyEvent: autoprobed model '$model', using it.\n" if $VERBOSE >= 2; 1212 warn "AnyEvent: autoloaded model '$model', using it.\n" if $VERBOSE >= 2;
1208 last; 1213 last;
1209 } 1214 }
1210 } 1215 }
1211 1216
1212 $MODEL 1217 $MODEL
1284} 1289}
1285 1290
1286# default implementation for ->signal 1291# default implementation for ->signal
1287 1292
1288our $HAVE_ASYNC_INTERRUPT; 1293our $HAVE_ASYNC_INTERRUPT;
1294
1295sub _have_async_interrupt() {
1296 $HAVE_ASYNC_INTERRUPT = 1*(!$ENV{PERL_ANYEVENT_AVOID_ASYNC_INTERRUPT}
1297 && eval "use Async::Interrupt 1.0 (); 1")
1298 unless defined $HAVE_ASYNC_INTERRUPT;
1299
1300 $HAVE_ASYNC_INTERRUPT
1301}
1302
1289our ($SIGPIPE_R, $SIGPIPE_W, %SIG_CB, %SIG_EV, $SIG_IO); 1303our ($SIGPIPE_R, $SIGPIPE_W, %SIG_CB, %SIG_EV, $SIG_IO);
1290our (%SIG_ASY, %SIG_ASY_W); 1304our (%SIG_ASY, %SIG_ASY_W);
1291our ($SIG_COUNT, $SIG_TW); 1305our ($SIG_COUNT, $SIG_TW);
1292 1306
1293sub _signal_exec { 1307sub _signal_exec {
1301 $_->() for values %{ $SIG_CB{$_} || {} }; 1315 $_->() for values %{ $SIG_CB{$_} || {} };
1302 } 1316 }
1303 } 1317 }
1304} 1318}
1305 1319
1306# install a dumym wakeupw atcher to reduce signal catching latency 1320# install a dummy wakeup watcher to reduce signal catching latency
1307sub _sig_add() { 1321sub _sig_add() {
1308 unless ($SIG_COUNT++) { 1322 unless ($SIG_COUNT++) {
1309 # try to align timer on a full-second boundary, if possible 1323 # try to align timer on a full-second boundary, if possible
1310 my $NOW = AnyEvent->now; 1324 my $NOW = AnyEvent->now;
1311 1325
1320sub _sig_del { 1334sub _sig_del {
1321 undef $SIG_TW 1335 undef $SIG_TW
1322 unless --$SIG_COUNT; 1336 unless --$SIG_COUNT;
1323} 1337}
1324 1338
1339our $_sig_name_init; $_sig_name_init = sub {
1340 eval q{ # poor man's autoloading
1341 undef $_sig_name_init;
1342
1343 if (_have_async_interrupt) {
1344 *sig2num = \&Async::Interrupt::sig2num;
1345 *sig2name = \&Async::Interrupt::sig2name;
1346 } else {
1347 require Config;
1348
1349 my %signame2num;
1350 @signame2num{ split ' ', $Config::Config{sig_name} }
1351 = split ' ', $Config::Config{sig_num};
1352
1353 my @signum2name;
1354 @signum2name[values %signame2num] = keys %signame2num;
1355
1356 *sig2num = sub($) {
1357 $_[0] > 0 ? shift : $signame2num{+shift}
1358 };
1359 *sig2name = sub ($) {
1360 $_[0] > 0 ? $signum2name[+shift] : shift
1361 };
1362 }
1363 };
1364 die if $@;
1365};
1366
1367sub sig2num ($) { &$_sig_name_init; &sig2num }
1368sub sig2name($) { &$_sig_name_init; &sig2name }
1369
1325sub _signal { 1370sub signal {
1371 eval q{ # poor man's autoloading {}
1372 # probe for availability of Async::Interrupt
1373 if (_have_async_interrupt) {
1374 warn "AnyEvent: using Async::Interrupt for race-free signal handling.\n" if $VERBOSE >= 8;
1375
1376 $SIGPIPE_R = new Async::Interrupt::EventPipe;
1377 $SIG_IO = AnyEvent->io (fh => $SIGPIPE_R->fileno, poll => "r", cb => \&_signal_exec);
1378
1379 } else {
1380 warn "AnyEvent: using emulated perl signal handling with latency timer.\n" if $VERBOSE >= 8;
1381
1382 require Fcntl;
1383
1384 if (AnyEvent::WIN32) {
1385 require AnyEvent::Util;
1386
1387 ($SIGPIPE_R, $SIGPIPE_W) = AnyEvent::Util::portable_pipe ();
1388 AnyEvent::Util::fh_nonblocking ($SIGPIPE_R, 1) if $SIGPIPE_R;
1389 AnyEvent::Util::fh_nonblocking ($SIGPIPE_W, 1) if $SIGPIPE_W; # just in case
1390 } else {
1391 pipe $SIGPIPE_R, $SIGPIPE_W;
1392 fcntl $SIGPIPE_R, &Fcntl::F_SETFL, &Fcntl::O_NONBLOCK if $SIGPIPE_R;
1393 fcntl $SIGPIPE_W, &Fcntl::F_SETFL, &Fcntl::O_NONBLOCK if $SIGPIPE_W; # just in case
1394
1395 # not strictly required, as $^F is normally 2, but let's make sure...
1396 fcntl $SIGPIPE_R, &Fcntl::F_SETFD, &Fcntl::FD_CLOEXEC;
1397 fcntl $SIGPIPE_W, &Fcntl::F_SETFD, &Fcntl::FD_CLOEXEC;
1398 }
1399
1400 $SIGPIPE_R
1401 or Carp::croak "AnyEvent: unable to create a signal reporting pipe: $!\n";
1402
1403 $SIG_IO = AnyEvent->io (fh => $SIGPIPE_R, poll => "r", cb => \&_signal_exec);
1404 }
1405
1406 *signal = sub {
1326 my (undef, %arg) = @_; 1407 my (undef, %arg) = @_;
1327 1408
1328 my $signal = uc $arg{signal} 1409 my $signal = uc $arg{signal}
1329 or Carp::croak "required option 'signal' is missing"; 1410 or Carp::croak "required option 'signal' is missing";
1330 1411
1331 $SIG_CB{$signal}{$arg{cb}} = $arg{cb};
1332
1333 if ($HAVE_ASYNC_INTERRUPT) { 1412 if ($HAVE_ASYNC_INTERRUPT) {
1334 # async::interrupt 1413 # async::interrupt
1335 1414
1336 $SIG_ASY{$signal} ||= do { 1415 $signal = sig2num $signal;
1337 my $asy = new Async::Interrupt 1416 $SIG_CB{$signal}{$arg{cb}} = $arg{cb};
1417
1418 $SIG_ASY{$signal} ||= new Async::Interrupt
1338 cb => sub { undef $SIG_EV{$signal} }, 1419 cb => sub { undef $SIG_EV{$signal} },
1339 signal => $signal, 1420 signal => $signal,
1340 pipe => [$SIGPIPE_R->filenos], 1421 pipe => [$SIGPIPE_R->filenos],
1422 pipe_autodrain => 0,
1423 ;
1424
1425 } else {
1426 # pure perl
1427
1428 # AE::Util has been loaded in signal
1429 $signal = sig2name $signal;
1430 $SIG_CB{$signal}{$arg{cb}} = $arg{cb};
1431
1432 $SIG{$signal} ||= sub {
1433 local $!;
1434 syswrite $SIGPIPE_W, "\x00", 1 unless %SIG_EV;
1435 undef $SIG_EV{$signal};
1436 };
1437
1438 # can't do signal processing without introducing races in pure perl,
1439 # so limit the signal latency.
1440 _sig_add;
1341 ; 1441 }
1342 $asy->pipe_autodrain (0);
1343 1442
1344 $asy 1443 bless [$signal, $arg{cb}], "AnyEvent::Base::signal"
1345 }; 1444 };
1346 1445
1347 } else { 1446 *AnyEvent::Base::signal::DESTROY = sub {
1348 # pure perl 1447 my ($signal, $cb) = @{$_[0]};
1349 1448
1350 $SIG{$signal} ||= sub { 1449 _sig_del;
1351 local $!; 1450
1352 syswrite $SIGPIPE_W, "\x00", 1 unless %SIG_EV; 1451 delete $SIG_CB{$signal}{$cb};
1452
1453 $HAVE_ASYNC_INTERRUPT
1454 ? delete $SIG_ASY{$signal}
1455 : # delete doesn't work with older perls - they then
1456 # print weird messages, or just unconditionally exit
1457 # instead of getting the default action.
1353 undef $SIG_EV{$signal}; 1458 undef $SIG{$signal}
1459 unless keys %{ $SIG_CB{$signal} };
1354 }; 1460 };
1355
1356 # can't do signal processing without introducing races in pure perl,
1357 # so limit the signal latency.
1358 _sig_add;
1359 } 1461 };
1360 1462 die if $@;
1361 bless [$signal, $arg{cb}], "AnyEvent::Base::signal"
1362}
1363
1364sub signal {
1365 # probe for availability of Async::Interrupt
1366 if (!$ENV{PERL_ANYEVENT_AVOID_ASYNC_INTERRUPT} && eval "use Async::Interrupt 0.6 (); 1") {
1367 warn "AnyEvent: using Async::Interrupt for race-free signal handling.\n" if $VERBOSE >= 8;
1368
1369 $HAVE_ASYNC_INTERRUPT = 1;
1370 $SIGPIPE_R = new Async::Interrupt::EventPipe;
1371 $SIG_IO = AnyEvent->io (fh => $SIGPIPE_R->fileno, poll => "r", cb => \&_signal_exec);
1372
1373 } else {
1374 warn "AnyEvent: using emulated perl signal handling with latency timer.\n" if $VERBOSE >= 8;
1375
1376 require Fcntl;
1377
1378 if (AnyEvent::WIN32) {
1379 require AnyEvent::Util;
1380
1381 ($SIGPIPE_R, $SIGPIPE_W) = AnyEvent::Util::portable_pipe ();
1382 AnyEvent::Util::fh_nonblocking ($SIGPIPE_R) if $SIGPIPE_R;
1383 AnyEvent::Util::fh_nonblocking ($SIGPIPE_W) if $SIGPIPE_W; # just in case
1384 } else {
1385 pipe $SIGPIPE_R, $SIGPIPE_W;
1386 fcntl $SIGPIPE_R, &Fcntl::F_SETFL, &Fcntl::O_NONBLOCK if $SIGPIPE_R;
1387 fcntl $SIGPIPE_W, &Fcntl::F_SETFL, &Fcntl::O_NONBLOCK if $SIGPIPE_W; # just in case
1388
1389 # not strictly required, as $^F is normally 2, but let's make sure...
1390 fcntl $SIGPIPE_R, &Fcntl::F_SETFD, &Fcntl::FD_CLOEXEC;
1391 fcntl $SIGPIPE_W, &Fcntl::F_SETFD, &Fcntl::FD_CLOEXEC;
1392 }
1393
1394 $SIGPIPE_R
1395 or Carp::croak "AnyEvent: unable to create a signal reporting pipe: $!\n";
1396
1397 $SIG_IO = AnyEvent->io (fh => $SIGPIPE_R, poll => "r", cb => \&_signal_exec);
1398 }
1399
1400 *signal = \&_signal;
1401 &signal 1463 &signal
1402}
1403
1404sub AnyEvent::Base::signal::DESTROY {
1405 my ($signal, $cb) = @{$_[0]};
1406
1407 _sig_del;
1408
1409 delete $SIG_CB{$signal}{$cb};
1410
1411 $HAVE_ASYNC_INTERRUPT
1412 ? delete $SIG_ASY{$signal}
1413 : # delete doesn't work with older perls - they then
1414 # print weird messages, or just unconditionally exit
1415 # instead of getting the default action.
1416 undef $SIG{$signal}
1417 unless keys %{ $SIG_CB{$signal} };
1418} 1464}
1419 1465
1420# default implementation for ->child 1466# default implementation for ->child
1421 1467
1422our %PID_CB; 1468our %PID_CB;
1423our $CHLD_W; 1469our $CHLD_W;
1424our $CHLD_DELAY_W; 1470our $CHLD_DELAY_W;
1425our $WNOHANG; 1471our $WNOHANG;
1426 1472
1473sub _emit_childstatus($$) {
1474 my (undef, $rpid, $rstatus) = @_;
1475
1476 $_->($rpid, $rstatus)
1477 for values %{ $PID_CB{$rpid} || {} },
1478 values %{ $PID_CB{0} || {} };
1479}
1480
1427sub _sigchld { 1481sub _sigchld {
1482 my $pid;
1483
1484 AnyEvent->_emit_childstatus ($pid, $?)
1428 while (0 < (my $pid = waitpid -1, $WNOHANG)) { 1485 while ($pid = waitpid -1, $WNOHANG) > 0;
1429 $_->($pid, $?)
1430 for values %{ $PID_CB{$pid} || {} },
1431 values %{ $PID_CB{0} || {} };
1432 }
1433} 1486}
1434 1487
1435sub child { 1488sub child {
1436 my (undef, %arg) = @_; 1489 my (undef, %arg) = @_;
1437 1490
2416L<Glib>, L<Tk>, L<Event::Lib>, L<Qt>, L<POE>. 2469L<Glib>, L<Tk>, L<Event::Lib>, L<Qt>, L<POE>.
2417 2470
2418Implementations: L<AnyEvent::Impl::EV>, L<AnyEvent::Impl::Event>, 2471Implementations: L<AnyEvent::Impl::EV>, L<AnyEvent::Impl::Event>,
2419L<AnyEvent::Impl::Glib>, L<AnyEvent::Impl::Tk>, L<AnyEvent::Impl::Perl>, 2472L<AnyEvent::Impl::Glib>, L<AnyEvent::Impl::Tk>, L<AnyEvent::Impl::Perl>,
2420L<AnyEvent::Impl::EventLib>, L<AnyEvent::Impl::Qt>, 2473L<AnyEvent::Impl::EventLib>, L<AnyEvent::Impl::Qt>,
2421L<AnyEvent::Impl::POE>, L<AnyEvent::Impl::IOAsync>. 2474L<AnyEvent::Impl::POE>, L<AnyEvent::Impl::IOAsync>, L<Anyevent::Impl::Irssi>.
2422 2475
2423Non-blocking file handles, sockets, TCP clients and 2476Non-blocking file handles, sockets, TCP clients and
2424servers: L<AnyEvent::Handle>, L<AnyEvent::Socket>, L<AnyEvent::TLS>. 2477servers: L<AnyEvent::Handle>, L<AnyEvent::Socket>, L<AnyEvent::TLS>.
2425 2478
2426Asynchronous DNS: L<AnyEvent::DNS>. 2479Asynchronous DNS: L<AnyEvent::DNS>.

Diff Legend

Removed lines
+ Added lines
< Changed lines
> Changed lines